Compare commits

...

8 Commits

Author SHA1 Message Date
knoflook ddda5da6bc chore: publish new release
continuous-integration/drone/push Build is failing Details
2023-10-20 15:54:13 +02:00
3wc 304468b8f4 chore: publish 0.6.2+3.1.1 release
continuous-integration/drone/push Build is failing Details
2023-10-19 11:04:19 +01:00
3wc 0ccf1d7a6c Fix healthcheck, sidekiq on proxy network
continuous-integration/drone/push Build is failing Details
2023-10-19 11:03:42 +01:00
3wc 1049c27c35 chore: publish 0.6.1+3.1.1 release
continuous-integration/drone/push Build is failing Details
2023-10-08 18:41:20 +01:00
3wc 03dc80d073 Add healthcheck for app container
continuous-integration/drone/push Build is failing Details
2023-10-08 18:40:49 +01:00
3wc 300f374af9 chore: publish 0.6.0+3.1.1 release
continuous-integration/drone/push Build is failing Details
2023-10-03 19:13:06 +01:00
3wc ec72949bfa chore: publish 0.5.0+3.0.6 release
continuous-integration/drone/push Build is failing Details
2023-08-21 15:57:39 +02:00
3wc 6a5f20bc8a Add postgres major version upgrade script 2023-08-21 15:56:57 +02:00
3 changed files with 69 additions and 10 deletions

1
abra.sh Normal file
View File

@ -0,0 +1 @@
export DB_ENTRYPOINT_VERSION=v1

View File

@ -3,7 +3,7 @@ version: "3.8"
services:
app:
image: bitnami/discourse:3.0.6
image: bitnami/discourse:3.1.2
networks:
- proxy
- internal
@ -43,22 +43,27 @@ services:
#- "traefik.http.routers.${STACK_NAME}.middlewares=${STACK_NAME}-redirect"
#- "traefik.http.middlewares.${STACK_NAME}-redirect.headers.SSLForceHost=true"
#- "traefik.http.middlewares.${STACK_NAME}-redirect.headers.SSLHost=${DOMAIN}"
- "coop-cloud.${STACK_NAME}.version=0.4.1+3.0.6"
# healthcheck:
# test: ["CMD", "curl", "-f", "http://localhost:3000"]
# interval: 30s
# timeout: 10s
# retries: 10
# start_period: 1m
- "coop-cloud.${STACK_NAME}.version=0.6.3+3.1.2"
healthcheck:
test: "ruby -e \"require 'uri'; require 'net/http'; uri = URI('http://localhost:3000/srv/status'); res = Net::HTTP.get_response(uri); if res.is_a?(Net::HTTPSuccess) then exit (0) else exit (1) end\""
interval: 30s
timeout: 10s
retries: 6
start_period: 5m
db:
image: postgres:13-alpine
image: postgres:13
networks:
- internal
secrets:
- db_password
volumes:
- 'postgresql_data:/var/lib/postgresql/data'
configs:
- source: db_entrypoint
target: /docker-entrypoint.sh
mode: 0555
entrypoint: /docker-entrypoint.sh
environment:
- POSTGRES_HOST_AUTH_METHOD=trust
- POSTGRES_USER=discourse
@ -79,8 +84,9 @@ services:
- 'redis_data:/data'
sidekiq:
image: bitnami/discourse:3.0.6
image: bitnami/discourse:3.1.2
networks:
- proxy
- internal
depends_on:
- discourse
@ -120,3 +126,9 @@ networks:
proxy:
external: true
internal:
configs:
db_entrypoint:
name: ${STACK_NAME}_db_entrypoint_${DB_ENTRYPOINT_VERSION}
file: entrypoint.postgres.sh.tmpl
template_driver: golang

View File

@ -0,0 +1,46 @@
#!/bin/bash
set -e
MIGRATION_MARKER=$PGDATA/migration_in_progress
OLDDATA=$PGDATA/old_data
NEWDATA=$PGDATA/new_data
echo "Running as $(id)"
if [ -e $MIGRATION_MARKER ]; then
echo "FATAL: migration was started but did not complete in a previous run. manual recovery necessary"
exit 1
fi
if [ -f $PGDATA/PG_VERSION ]; then
DATA_VERSION=$(cat $PGDATA/PG_VERSION)
if [ -n "$DATA_VERSION" -a "$PG_MAJOR" != "$DATA_VERSION" ]; then
echo "postgres data version $DATA_VERSION found, but need $PG_MAJOR. Starting migration"
echo "Installing postgres $DATA_VERSION"
sed -i "s/$/ $DATA_VERSION/" /etc/apt/sources.list.d/pgdg.list
apt-get update && apt-get install -y --no-install-recommends \
postgresql-$DATA_VERSION \
&& rm -rf /var/lib/apt/lists/*
echo "shuffling around"
gosu postgres mkdir $OLDDATA $NEWDATA
chmod 700 $OLDDATA $NEWDATA
mv $PGDATA/* $OLDDATA/ || true
touch $MIGRATION_MARKER
echo "running initdb"
# abuse entrypoint script for initdb by making server error out
gosu postgres bash -c "export PGDATA=$NEWDATA ; /usr/local/bin/docker-entrypoint.sh --invalid-arg || true"
echo "running pg_upgrade"
cd /tmp
gosu postgres pg_upgrade --link -b /usr/lib/postgresql/$DATA_VERSION/bin -d $OLDDATA -D $NEWDATA -U $POSTGRES_USER
cp $OLDDATA/pg_hba.conf $NEWDATA/
mv $NEWDATA/* $PGDATA
rm -rf $OLDDATA
rmdir $NEWDATA
rm $MIGRATION_MARKER
echo "migration complete"
fi
fi
/usr/local/bin/docker-entrypoint.sh postgres